LeetCode 210 course schedule 2

Tech In Pieces發表於2020-11-27

now instead of just checking on whether we can finish all the courses or not, we are now asked to return the order of courses that you should take to finish all the courses.
we only needs to return one path if there exist any of these paths

public int[] findOrder(int numCourses, int[][] prerequisites)

so the idea for this problem is:
we starting from each head we can found, and check them out on it’s every neighbor, and we go and go until the queue is empty(bfs) is finished. and during the whole process, keeps recording of every node we’ve been through, and in the last, check the number of different node we have been through, if the number is numCourses, then we found it, return the res.

BFS solution, using queue

class Solution {
    public int[] findOrder(int numCourses, int[][] prerequisites) {
        int[] indegree = new int[numCourses];
        int[] res = new int[numCourses];
        int k = 0;
        for (int[] pair : prerequisites) { //get the indegree of each node
            indegree[pair[0]]++;
        }
        Queue<Integer> queue = new LinkedList<>();
        for (int i = 0; i < indegree.length; i++) { //check which of indgree is 0, if it is 0, we can start from it
            if (indegree[i] == 0) {
                queue.offer(i);
                res[k++] = i;
            }
        }
        //now all of our head is in the queue
        while (!queue.isEmpty()) {
            int pre = queue.poll();
            for (int[] pair : prerequisites) { //we check each pair
                if (pair[1] == pre) {
                    indegree[pair[0]]--;
                    if (indegree[pair[0]] == 0) { //this should be 0, because otherwise it means there are other node that into this too
                        queue.offer(pair[0]);
                        res[k++] = pair[0];
                    }
                }
            }
        }
        return (k == numCourses) ? res : new int[0];
    }
}

相關文章